VERSION 5.00
Begin VB.Form Timevb32 
   Caption         =   "Time"
   ClientHeight    =   4065
   ClientLeft      =   1065
   ClientTop       =   1845
   ClientWidth     =   7515
   Icon            =   "Timevb32.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4065
   ScaleWidth      =   7515
   Begin VB.CommandButton ButtonSetClock 
      Caption         =   "Set 1994 To PC's Clock"
      Height          =   495
      Left            =   840
      TabIndex        =   6
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label6 
      Caption         =   "Error reading time"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   5
      Top             =   3600
      Width           =   6615
   End
   Begin VB.Label Label5 
      Caption         =   "Error reading Rom number"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   2880
      Width           =   6615
   End
   Begin VB.Label Label4 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   240
      TabIndex        =   3
      Top             =   1920
      Width           =   7215
   End
   Begin VB.Label Label3 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   1440
      Width           =   6615
   End
   Begin VB.Label Label2 
      Caption         =   "Version 3.10"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   5520
      TabIndex        =   1
      Top             =   840
      Width           =   1455
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   5880
      Picture         =   "Timevb32.frx":0A8A
      Top             =   120
      Width           =   480
   End
   Begin VB.Label Label1 
      Caption         =   "iButton"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   5760
      TabIndex        =   0
      Top             =   600
      Width           =   975
   End
End
Attribute VB_Name = "Timevb32"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub ButtonSetClock_Click()
    Dim TempLong As Long
    Dim SHandle As Long
    Dim i As Integer
    Dim TimeBuffer(4) As Integer
    Dim romstr As String
    Dim ROM(8) As Integer
    Dim ReadBackBuff(8) As Integer
    Dim TBresult As Integer
       
'// Get PC time in seconds since 1970 and Split up TotSeconds into an array of 4 separate bytes.
    TempLong = ConvertTimeToSeconds
    TimeBuffer(4) = TempLong Mod 256
    TimeBuffer(3) = (TempLong \ (256 ^ 1)) Mod 256
    TimeBuffer(2) = (TempLong \ (256 ^ 2)) Mod 256
    TimeBuffer(1) = TempLong \ (256 ^ 3)
        
'// Start session
    SHandle = TMExtendedStartSession(PortNum, PortType, vbNullString)
    If (SHandle <= 0) Then
        MsgBox ("Error:  Failed to Start TMEX Session!")
    End If
    
'///////////////////////////////////////////////////////////////////////
'/////////////////// Send Data to DS1994. //////////////////////////////
'///////////////////////////////////////////////////////////////////////
'// Find First DS1994 on bus
    If TMFamilySearchSetup(SHandle, state_buffer(0), &H4) <> 1 Then
        MsgBox ("Error:  DS1994 not found on MicroLan, FamilySearch returned error.")
        TMEndSession (SHandle)
        Exit Sub
    End If
    If TMNext(SHandle, state_buffer(0)) <> 1 Then
        MsgBox ("Error:  DS1994 not found on MicroLan, TMNext returned error.")
        TMEndSession (SHandle)
        Exit Sub
    End If
'// Read the ROM number
    ROM(0) = 0
    If TMRom(SHandle, state_buffer(0), ROM(0)) <> 1 Then
        MsgBox ("Error:  TMRom returned error.")
        TMEndSession (SHandle)
        Exit Sub
    End If
    For i = 7 To 0 Step -1
        If (ROM(i) <= &HF) Then
            romstr = romstr + "0" + Hex$(ROM(i))
        Else
            romstr = romstr + Hex$(ROM(i))
        End If
    Next i
'// Print the Rom string if you like.
    'Debug.Print ("Rom string:  ")
    'Debug.Print (romstr)

'// Write Scratchpad of DS19xx.
     TBresult = TMTouchByte(SHandle, &HF)
     TBresult = TMTouchByte(SHandle, &H2)    '// Address TA1
     TBresult = TMTouchByte(SHandle, &H2)    '// Address TA2
     TBresult = TMTouchByte(SHandle, &H0)    '// first byte represents fractional seconds--always zero.
     For i = 4 To 1 Step -1                          '// write data to scratchpad.
         TBresult = TMTouchByte(SHandle, TimeBuffer(i))
     Next i
'// Read Scratchpad.
     If TMAccess(SHandle, state_buffer(0)) <> 1 Then  '// Re-Access the part
         MsgBox ("Error:  Could Not Access iButton! Read Scratchpad error")
         TMEndSession (SHandle)
         Exit Sub
     End If
     TBresult = TMTouchByte(SHandle, &HAA)
     For i = 1 To 8
         ReadBackBuff(i) = TMTouchByte(SHandle, &HFF)
     Next i
'// Copy Scratchpad.
     If TMAccess(SHandle, state_buffer(0)) <> 1 Then '// Re-Access the part
         MsgBox ("Error:  Could Not Access iButton! Copy Scratchpad error")
         TMEndSession (SHandle)
         Exit Sub
     End If
     TBresult = TMTouchByte(SHandle, &H55)
     TBresult = TMTouchByte(SHandle, &H2)
     TBresult = TMTouchByte(SHandle, &H2)
     TBresult = TMTouchByte(SHandle, &H6)
'///////////////////////////////////////////////////////////////////////
'///////////// Finished Sending Data to DS1994. ////////////////////////
'///////////////////////////////////////////////////////////////////////
'// Read Time of DS1994 Back to Form
     ReadTime (SHandle)
'// End TMEX session
     TMEndSession (SHandle)

End Sub

